#pragma once

#include "CoreMinimal.h"
#include "Interactable.h"
#include "Templates/SubclassOf.h"
#include "WormholeFatherDeadBody.generated.h"

class UStaticMeshComponent;
class USceneComponent;
class AWormholeFatherKeyCard;
class UBoxPlayerOverlapComponent;
class UInteractor;
class UCollectFatherKeyCardInteraction;
class AActor;

UCLASS(Blueprintable)
class DBDGAMEPLAY_API AWormholeFatherDeadBody : public AInteractable
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear, Instanced)
	UStaticMeshComponent* _wrmFatherDeadBodyStaticMesh;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	USceneComponent* _wrmFatherKeyCardAttachment;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<AWormholeFatherKeyCard> _wrmFatherEasterEggKeyCardStaticClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UBoxPlayerOverlapComponent* _wrmFatherKeyCardInteractableZone;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UInteractor* _wrmKeyCardFirstCollectionInteractor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UCollectFatherKeyCardInteraction* _fatherKeyCardCollectionInteraction;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	AActor* _wrmFatherEasterEggSpawnedKeyCard;

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	AWormholeFatherDeadBody();
};

FORCEINLINE uint32 GetTypeHash(const AWormholeFatherDeadBody) { return 0; }
